//+------------------------------------------------------------------+
//|                                 Test Trade Transaction Event.mq5 |
//|                                         Copyright 2018, Odera FX |
//|                             https://www.mql5.com/en/users/skillz |
//+------------------------------------------------------------------+
#property copyright "Copyright 2018, Odera FX"
#property link      "https://www.mql5.com/en/users/skillz"
#property version   "1.00"
bool first = false;
#include <Trade\\Trade.mqh>
CTrade TF();
int Magic = 1234;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
   TF.SetExpertMagicNumber(Magic);
   TF.SetAsyncMode(false);
   TF.SetDeviationInPoints(30);
   
//---
   first = true;
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
   static datetime last = 0;
   if (last == 0) 
   {
    double price = SymbolInfoDouble(_Symbol,SYMBOL_ASK) + (400*_Point);
    bool open = TF.OrderOpen(_Symbol,ORDER_TYPE_BUY_STOP,0.1,0,price,0,0);
    if (open)
    {
     last = TimeCurrent();
    }
   }
   else
   {
    if (TimeCurrent() > last+5) 
    {
     int count = OrdersTotal();
     for(int i=count-1;i>=0;i--)
       {
        ulong ticket = 0;
        if ((ticket = OrderGetTicket(i)) > 0)
        {
         if (OrderGetInteger(ORDER_MAGIC) == Magic && OrderGetString(ORDER_SYMBOL) == _Symbol)
         {
          TF.OrderDelete(ticket);
          
         }
        }
       }
     last = 0;
    }
   }
  }
//+------------------------------------------------------------------+
//| Trade function                                                   |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//| TradeTransaction function                                        |
//+------------------------------------------------------------------+
void OnTradeTransaction(const MqlTradeTransaction& trans,
                        const MqlTradeRequest& request,
                        const MqlTradeResult& result)
  {
//---
   if (trans.type == TRADE_TRANSACTION_REQUEST)
   {
    if (request.action == TRADE_ACTION_REMOVE && result.retcode == 10009)
    {
     Print(" Order deleted! magic ",request.magic," result ticket ",result.order);
    }
   }
  }
//+------------------------------------------------------------------+
